#version 450
#extension GL_EXT_buffer_reference : require

layout(set = 0, binding = 0) uniform UIUniform {
  mat4 screen;
} ubo;

layout(location = 0) in vec3 inPolygonPosition;
layout(location = 1) in vec2 inPolygonSize;
layout(location = 2) in vec4 inColor;

layout(location = 0) out vec4 fragColor;

const vec2 square[6] = {
  vec2(0.0, 0.0),
  vec2(1.0, 0.0),
  vec2(0.0, 1.0),
  vec2(1.0, 0.0),
  vec2(1.0, 1.0),
  vec2(0.0, 1.0),
};

void main() {
  gl_Position = ubo.screen * vec4(vec3(square[gl_VertexIndex] * inPolygonSize, 0.0) + inPolygonPosition, 1.0);
  fragColor = inColor;
}

